var Control = ol.control.Control;
var MapConfig = /*@__PURE__*/(function (Control) {
  function MapConfigControl(opt_options) {
    var settings = opt_options || {};

    var element = document.createElement('div');
    element.className = 'ol-unselectable ol-control';
    element.innerHTML = 'ME';

    Control.call(this, {
      element: element,
      target: settings.target,
    });
    
    element.addEventListener('click', this.handleMapConfig.bind(this, settings), false);
  }
  
  if ( Control ) MapConfigControl.__proto__ = Control;
  MapConfigControl.prototype = Object.create( Control && Control.prototype );
  MapConfigControl.prototype.constructor = MapConfigControl;
  
  MapConfigControl.prototype.handleMapConfig = function handleMapConfig (settings) {
    console.log("MaxExtent");
    var extent = this.getMap().getView().calculateExtent(this.getMap().getSize());
    extent = ol.proj.transformExtent(extent, ol.proj.get('EPSG:3857'), ol.proj.get('EPSG:4326'));
    var xMin = extent[0];
    if(xMin < -180.0) {
      xMin = - 180.0;
    }
    var xMax = extent[2];
    if(xMax > 180.0) {
      xMax = 180.0;
    } 
    var yMin = extent[1];
    if(yMin < -90.0) {
      yMin = -90.0;
    }
    var yMax = extent[3];
    if(yMax > 90.0) {
      yMax = 90.0;
    }
    document.getElementById("edit-max-extent-0-value").value = xMin + "," + yMin + "," + xMax + "," + yMax; 
  }
  return MapConfigControl;
}(Control));

window.onload = function() { 
  console.log("window.onload");
  var map = document.getElementById("openlayers-map").data;
  document.getElementById("openlayers-map").style.height = document.getElementById("edit-map-height-0-value").value + "px";
  map.updateSize();
  document.getElementById("edit-map-height-0-value").onchange = function(){
      document.getElementById("openlayers-map").style.height = document.getElementById("edit-map-height-0-value").value + "px";
      document.getElementById("openlayers-map").data.updateSize();
  }
  var coords = document.getElementById("edit-center-0-value").value.split(",");
  if(coords.length === 2) {
    map.getView().setCenter([parseFloat(coords[0]),parseFloat(coords[1])]);
  } 
  console.log(document.getElementById("edit-zoom-0-value").value);
  map.getView().setZoom(document.getElementById("edit-zoom-0-value").value);

  function onMoveEnd(evt){
      var map = evt.map;
      var center = map.getView().getCenter();
      center = ol.proj.transform(center,ol.proj.get('EPSG:3857'), ol.proj.get('EPSG:4326'));
      var zoom = map.getView().getZoom();
      document.getElementById("edit-center-0-value").value = center;
      document.getElementById("edit-zoom-0-value").value = zoom;
  };
  map.on('moveend', onMoveEnd);    
}