var Control = ol.control.Control;
var Geolocation = /*@__PURE__*/(function (Control) {
  function GeolocationControl(opt_options) {
    var settings = opt_options || {};
    
    var button = document.createElement('img');
    button.title = settings.tooltip;
    button.className = "ol-control-icon";
    var protocol = location.protocol;
    var slashes = protocol.concat("//");
    var host = slashes.concat(window.location.hostname);
    button.src = host + settings.path +"/img/" + settings.icon;

    var element = document.createElement('div');
    element.className = 'ol-unselectable ol-control';
    element.appendChild(button);
    
    Control.call(this, {
      element: element,
      target: settings.target
    });
    
    button.addEventListener('click', this.handleGeolocation.bind(this, settings), false);
    button.addEventListener('touchstart', this.handleGeolocation.bind(this, settings), false); 
  }
  
  if ( Control ) GeolocationControl.__proto__ = Control;
  GeolocationControl.prototype = Object.create( Control && Control.prototype );
  GeolocationControl.prototype.constructor = GeolocationControl;
  
  GeolocationControl.prototype.handleGeolocation = function handleGeolocation (settings) {
    var geolocation = new ol.Geolocation({
      tracking: true,
      projection: this.getMap().getView().getProjection(),
    });
    var temp_view = this.getMap().getView();
    var extent = null;
    if(this.getMap().getView().options_.extent) {
      extent = this.getMap().getView().options_.extent;
    }   

    setTimeout(function(){
      var pos = geolocation.getPosition();
      if(typeof pos !== 'undefined') {
        if(ol.extent.containsCoordinate(extent, pos)) {
          temp_view.setCenter(pos);
        } else {
          console.log("Position is out of extent");  
        }
      } else {
        console.log('can not get geolocation');
      };
    }, 1000, geolocation, temp_view, extent);
  }
  return GeolocationControl;
}(Control));